## Copyright (C) 2019 Mark
## 
## This program is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

## -*- texinfo -*- 
## @deftypefn {} {@var{retval} =} sid_octave (@var{input1}, @var{input2})
##
## @seealso{}
## @end deftypefn

## Author: Mark <markw@Eraze>
## Created: 2019-11-12

function [st,p_t,ps,pst] = sid_octave ()

fid = fopen("tables.bin");
val = fread (fid);

a = 1;
b = a+4096;
st = val(a:b-1);
a = b;
b = a+2048;
p_t = val(a:b-1);
a = b;
b = a+4096;
ps = val(a:b-1);
a = b;
b = a+4096;
pst = val(a:b-1);

close all;
figure
plot(st);
hold all;
plot(p_t);
plot(ps);
plot(pst);
legend({'st','p_t','ps','pst'});

emptyblocks(st,'st');
emptyblocks(p_t,'p_t');
emptyblocks(ps,'ps');
emptyblocks(pst,'pst');

endfunction

function emptyblocks(thing, name)
  
  minbits = inf;
  for bsl=1:log2(numel(thing))
    bs = 2^bsl;
    pts = 1:bs:numel(thing);
    content = 0;
    blocks = numel(thing)/bs;
    for j=1:numel(pts)
      it = thing(pts(j):pts(j)+bs-1);
      content = content+any(it~=0);
    end
    bits = content*bs*8 + blocks;
    if bits<minbits
      minbits = bits;
      minbs = bs;
    end
  end
  
  bs = minbs;
  pts = 1:bs:numel(thing);
  content = 0;
  blocks = numel(thing)/bs;
  for j=1:numel(pts)
    it = thing(pts(j):pts(j)+bs-1);
    content = content+any(it~=0);
  end
  bits = content*bs*8 + blocks;
     
  fprintf('%d: %s has %d/%d full blocks = %d bits/ %d bits\n',bs,name,content,blocks,bits,numel(thing)*8);      
  
endfunction
