function sidcheck(bits,chip,mixfunction)

if ~exist('chip','var')  || isempty(chip)
   chip = 19;
end

sidwaves = sidwavereader();

bitsidx = (2.^bits);
mixedidx = sum(bitsidx);

[bitsidx]+1
[mixedidx]+1

close all;
plot(sidwaves(:,chip,[bitsidx]+1));
hold all
plot(sidwaves(:,chip,[mixedidx]+1));

if ismember(1,bits) %When mixing sawtooth, triangle wave changes!
  sidwaves(2049:end,:,2) = sidwaves(1:2048,:,2);
  %https://www.lemon64.com/forum/viewtopic.php?t=25442&postdays=0&postorder=asc&start=165
end  

inbits = to_bits(sidwaves(:,chip,[1 2 4 8]+1));
targetbits = to_bits(sidwaves(:,chip,[mixedidx]+1));

logbits(inbits,targetbits);

mixedbits = mixfunction(inbits,bits+1,targetbits);

mixed = from_bits(mixedbits);
%mixed = from_bits(targetbits);

plot(mixed);
bitsstr = strsplit(num2str(bits));
legend([bitsstr,'real','func']);
figure
plot(mixed);
title('generated vs original');
hold all;
plot(sidwaves(:,chip,[mixedidx]+1));
plot(5000+mixed-sidwaves(:,chip,[mixedidx]+1));
plot(-5000+mixed);
plot(-10000+sidwaves(:,chip,[mixedidx]+1));
legend({'generated','original','error','genshift','origshift'});
%figure
%plot(sidwaves(:,chip,[1]+1)-sidwaves(:,chip,[mixedidx]+1));

t = 1:4096;
csvwrite('gen.csv',[t',mixed]);

endfunction

function inbits = to_bits(in)
  bitvals = permute(2.^[0:11],[4 3 1 2]);  
  inbits = zeros([size(in,1),size(in,2),size(in,3),12]);
  for b=1:12
    inbits(:,:,:,b) = bitand(in,bitvals(:,:,:,b))~=0;
  end
endfunction

function out = from_bits(outbits)
    bitvals = permute(2.^[0:11],[4 3 1 2]);    
    outvals = outbits.*bitvals;
    %outvals(outvals~=max(outvals)) = 0;
    out = sum(outvals,4);
endfunction

function logbits(inbits,targetbits)
    if i==520
      idx = 1:4096;
      x = [permute(targetbits(idx,1,1,:),[1 4 3 2]) ...
      permute(inbits(idx,1,1,:),[1 4 3 2]) ... 
      permute(inbits(idx,1,2,:),[1 4 3 2]) ...
      and(permute(inbits(idx,1,1,:),[1 4 3 2]),permute(inbits(idx,1,2,:),[1 4 3 2])) ...
      (permute(inbits(idx,1,1,:),[1 4 3 2])~=permute(inbits(idx,1,2,:),[1 4 3 2]))...
      ];
      for z=1:size(x,1)
        printf('%d ',z);
        for q=1:12
          printf('%d',x(z,q));
        end
        printf(' ');
        for q=13:24
          printf('%d',x(z,q));
        end        
        printf(' ');
        for q=25:36
          printf('%d',x(z,q));
        end   
        printf(' ');
        for q=37:48
          printf('%d',x(z,q));
        end 
        printf(' ');
        for q=49:60
          printf('%d',x(z,q));
        end           
        printf('\n');
      end
      sdfdsf=5;
      printf('hi')
    end
endfunction